
<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="renderer" content="webkit">
    <meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
    <title>C++ 异常机制（下） / 开普饭 </title>
    <meta name="description" content="C++ 异常机制（下） 目录 八.C++标准异常类 九.编写自己的异常类 十.继承在异常中的应用 八.C++标准异常类 C++标准库异常类继承层次中的根类为exception,其定义在exception头文件中,它是C++标准库所有函数抛出异常的基类,exception的接口定义如下: namespace std { class exception { public: exception() throw(); //不抛出任何异常 exception(const exception&amp; e) throw(); ex ..." />
    <meta name="applicable-device" content="pc,mobile" />
          
    <link rel='dns-prefetch' href='//pic.ikafan.com' />
    <link rel='stylesheet' id='stylesheet-css' href='//n4.ikafan.com/assetsj/style.css' type='text/css' media='all' />
    <!-- <link rel='stylesheet' id='stylesheet-css'  href='https://computeinit.com/wp-content/themes/justnews/css/style.css?ver=6.9.2' type='text/css' media='all' /> -->
      
    <script src="https://n4.ikafan.com/g/show.js"></script>
        <!--[if lte IE 9]><script src="//n4.ikafan.com/assetsj/update.js"></script><![endif]-->
</head>
<body class="archive qapress-list el-boxed">

<header class="header">
    <div class="container clearfix">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse" aria-label="menu">
                <span class="icon-bar icon-bar-1"></span>
                <span class="icon-bar icon-bar-2"></span>
                <span class="icon-bar icon-bar-3"></span>
            </button>
                        <div class="logo">
                <a href="/" rel="home"><img src="//n4.ikafan.com/assetsj/logo.png" alt="开普饭"></a>
            </div>
        </div>
        <div class="collapse navbar-collapse">
            <nav class="navbar-left primary-menu">
                <ul id="menu-justnews-menu" class="nav navbar-nav wpcom-adv-menu">
                                        <li class="menu-item"><a href="/about/hot/">热门推荐</a></li>
                                        <li class="menu-item"><a href="/about/new/">最新更新</a></li>
                                        <li class="menu-item"><a href="/about/editor/">编辑推荐</a></li>
                                   
                </ul>
            </nav>            
            <!-- <div class="navbar-action pull-right">
                <div class="navbar-search-icon j-navbar-search"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-search"></use></svg></i></div>
                <div id="j-user-wrap"> 
                </div>
                <a class="btn btn-primary btn-xs" href="#">
                    xxx</a>
            </div>
            <form class="navbar-search" action="/search/" method="get" role="search">
                <div class="navbar-search-inner">
                    <i class="wpcom-icon wi navbar-search-close"><svg aria-hidden="true"><use xlink:href="#wi-close"></use></svg></i>                    <input type="text" name="s" class="navbar-search-input" autocomplete="off" placeholder="输入关键词搜索..." value="">
                    <button class="navbar-search-btn" type="submit"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-search"></use></svg></i></button>
                </div>
            </form> -->
        </div><!-- /.navbar-collapse -->
    </div><!-- /.container -->
</header><div id="wrap">    
    <div class="wrap container">
        <main class="main">
            <article class="entry">
                <div class="entry-main">
                    <div class="entry-head">
                        <h1 class="entry-title">C++ 异常机制（下）</h1>
                        <div class="entry-info">
                            <time class="entry-date published"  pubdate>2024-02-12 08:17:20</time>  
                        </div>                    </div>
                    <div id="single_top"></div>
<script>insertAdIfNeeded();</script>                        <!-- <div class="entry-excerpt entry-summary">
                            
                        </div> -->
                    <div class="entry-content">
                        <div>目录</div>
<ul><li>八、C++标准异常类</li>
<li>九、编写自己的异常类</li>
<li>十、继承在异常中的应用</li></ul>

<h3>八、C++标准异常类</h3>
<p>C++标准库异常类继承层次中的根类为exception，其定义在exception头文件中，它是C++标准库所有函数抛出异常的基类，exception的接口定义如下：</p>
<pre><code>namespace std {

     class exception {

     public:

          exception() throw();  //不抛出任何异常

          exception(const exception&amp; e) throw();

          exception&amp; operator= (const exception&amp; e) throw();

          virtual ~exception() throw)();

          virtual const char* what() const throw(); //返回异常的描述信息

     };

}
</code></pre>
<div><img src="//n4.ikafan.com/assetsj/blank.gif" class="j-lazy" loading="lazy" data-original='//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UxMDkuMzYwZG9jLmNuL0Rvd25sb2FkSW1nLzIwMjEvMDUvMjEwOC8yMjI1NTkzNjZfMV8yMDIxMDUyMTA4MjAyMjQ5MC5qcGc=.jpg' /></div>
<p>先来看一下 exception 类的直接派生类：</p>
<table>
<thead>
<tr>
<th>异常名称</th>
<th>说 明</th>
</tr>
</thead>
<tbody>
<tr>
<td>logic_error</td>
<td>逻辑错误。</td>
</tr>
<tr>
<td>runtime_error</td>
<td>运行时错误。</td>
</tr>
<tr>
<td>bad_alloc</td>
<td>使用 new 或 new[ ] 分配内存失败时抛出的异常。</td>
</tr>
<tr>
<td>bad_typeid</td>
<td>使用 typeid 操作一个 NULL 指针，而且该指针是带有虚函数的类，这时抛出 bad_typeid 异常。</td>
</tr>
<tr>
<td>bad_cast</td>
<td>使用 dynamic_cast 转换失败时抛出的异常。</td>
</tr>
<tr>
<td>ios_base::failure</td>
<td>io 过程中出现的异常。</td>
</tr>
<tr>
<td>bad_exception</td>
<td>这是个特殊的异常，如果函数的异常列表里声明了 bad_exception 异常，当函数内部抛出了异常列表中没有的异常时，如果调用的 unexpected() 函数中抛出了异常，不论什么类型，都会被替换为 bad_exception 类型。</td>
</tr>
</tbody>
</table>
<p>logic_error 的派生类：</p>
<table>
<thead>
<tr>
<th>异常名称</th>
<th>说 明</th>
</tr>
</thead>
<tbody>
<tr>
<td>length_error</td>
<td>试图生成一个超出该类型最大长度的对象时抛出该异常，例如 vector 的 resize 操作。</td>
</tr>
<tr>
<td>domain_error</td>
<td>参数的值域错误，主要用在数学函数中，例如使用一个负值调用只能操作非负数的函数。</td>
</tr>
<tr>
<td>out_of_range</td>
<td>超出有效范围。</td>
</tr>
<tr>
<td>invalid_argument</td>
<td>参数不合适。在标准库中，当利用string对象构造 bitset 时，而 string 中的字符不是 0 或1 的时候，抛出该异常。</td>
</tr>
</tbody>
</table>
<p>runtime_error 的派生类：</p>
<table>
<thead>
<tr>
<th>异常名称</th>
<th>说 明</th>
</tr>
</thead>
<tbody>
<tr>
<td>range_error</td>
<td>计算结果超出了有意义的值域范围。</td>
</tr>
<tr>
<td>overflow_error</td>
<td>算术计算上溢。</td>
</tr>
<tr>
<td>underflow_error</td>
<td>算术计算下溢。</td>
</tr>
</tbody>
</table>
<h3>九、编写自己的异常类</h3>
<p>原则：建议继承标准异常类，并重载父类的what函数和析构函数</p>
<pre><code>#define _CRT_SECURE_NO_WARNINGS
#include &lt;iostream&gt;
#include&lt;stdexcept&gt;
using namespace std;

class Person {
public:
Person() {
mAge = 0;
}
void setAge(int age) {
if (age &lt; 0 || age &gt; 100) {
throw out_of_range("年龄应该在0-100之间!");
}
this-&gt;mAge = age;
}
public:
int mAge;
};
//test01()使用标准库的异常类，下面的exception可以换为out_of_range
void test01() {
Person p;
try {
p.setAge(1000);
}
catch (exception e) {
cout &lt;&lt; e.what() &lt;&lt; endl;
}
}

//自己写个异常类，重载父类的what函数和析构函数
class MyOutOfRange : public exception {
public:
MyOutOfRange(const char* error) {
pError = new char[strlen(error) + 1];
strcpy(pError, error);
}
~MyOutOfRange() {
if (pError != NULL) {
delete[] pError;
}
}
virtual const char* what() const {
return pError;
};
public:
char* pError;
};

void fun02() {
throw MyOutOfRange("我自己的out_of_range!");
}

void test02() {
try {
fun02();
}
catch (exception&amp; e) {
cout &lt;&lt; e.what() &lt;&lt; endl;
}
}

int main(void)
{
test01();//结果：年龄应该在0-100之间!
//test02();//结果：我自己的out_of_range!
return 0;
}
</code></pre>
<h3>十、继承在异常中的应用</h3>
<p>异常尽量抛个类对象（基类），不要再用 -1 或 char* 。</p>
<pre><code>#define _CRT_SECURE_NO_WARNINGS
#include &lt;iostream&gt;
using namespace std;

//异常基类
class BaseMyException {
public:
virtual void  what() = 0;
virtual ~BaseMyException() {}
};

class TargetSpaceNullException : public BaseMyException {
public:
virtual void  what() {
cout &lt;&lt; "目标空间空!" &lt;&lt; endl;
}
~TargetSpaceNullException() {}
};

class SourceSpaceNullException : public BaseMyException {
public:
virtual void  what() {
cout &lt;&lt; "源空间为空!" &lt;&lt; endl;
}
~SourceSpaceNullException() {}
};
void copy_str(char* taget, char* source) {

if (taget == NULL) {
throw TargetSpaceNullException();
}
if (source == NULL) {
throw SourceSpaceNullException();
}

//int len = strlen(source) + 1;
while (*source != '\0') {
*taget = *source;
taget++;
source++;
}
}
int main(void) {

const char* source = "abcdefg";
char buf[1024] = { 0 };
try {
copy_str(buf, NULL);
}
catch (BaseMyException&amp; ex) {
ex.what();
}

cout &lt;&lt; buf &lt;&lt; endl;
return 0;
}
//结果：源空间为空!
</code></pre>                        <div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>                                                  
                     </div>

                    <div class="entry-tag"></div>
                                            <div class="entry-action">
                            <div class="btn-zan" data-id="7544"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-thumb-up-fill"></use></svg></i> 赞 <span class="entry-action-num">(0)</span></div>
                        </div>
                    
                    
                </div>
                <!-- <div class="sec-panel main-list main-list-default">
                    <div class="tab-wrap active">
                        <ul class="post-loop post-loop-default cols-3">
                             
                        </ul>
                    </div>
                </div>  -->
                 
                <div class="entry-related-posts">
                    <h3 class="entry-related-title">相关推荐</h3>
                    <ul class="entry-related post-loop-default">
                     
 
                    </ul>
                </div>  
                                            </article>
        </main>

<aside class="sidebar">
    <div id="wpcom-lastest-news-3" class="widget widget_lastest_news"><h3 class="widget-title"><span>热门文章</span></h3>            
        <ul>
                                    <li><a href="https://www.kpfans.com/article/z4W1dOK9jy.html" title="武汉汉剧全剧《四郎探母》第一集">武汉汉剧全剧《四郎探母》第一集</a></li>
                        <li><a href="https://www.kpfans.com/article/mdWnd3JLvM.html" title="B4U2复习微课">B4U2复习微课</a></li>
                        <li><a href="https://www.kpfans.com/article/rLvBAxdx5d.html" title="【Q002】肺尖肿瘤综合征">【Q002】肺尖肿瘤综合征</a></li>
                        <li><a href="https://www.kpfans.com/article/wLWoJxAN9j.html" title="Eugen Chisnicean水彩画欣赏">Eugen Chisnicean水彩画欣赏</a></li>
                        <li><a href="https://www.kpfans.com/article/7OWgnB2K9J.html" title="河粉文学沙龙II青梅画专辑">河粉文学沙龙II青梅画专辑</a></li>
                        <li><a href="https://www.kpfans.com/article/GB972YeMvE.html" title="血与火的东线：苏军开战后几天就开始利用缴获装备 抵御德军进攻">血与火的东线：苏军开战后几天就开始利用缴获装备 抵御德军进攻</a></li>
                        <li><a href="https://www.kpfans.com/article/Yo5JynzJW4.html" title="芦根这样用，美味又健康">芦根这样用，美味又健康</a></li>
                        <li><a href="https://www.kpfans.com/article/pO9PnM1Z5a.html" title="中国当代著名油画画家谢华业：雷州人民的守护神——雷州石狗">中国当代著名油画画家谢华业：雷州人民的守护神——雷州石狗</a></li>
                        <li><a href="https://www.kpfans.com/article/RK5EgGaX9D.html" title="仿佛能闻到花香-2019玫瑰花车大赏">仿佛能闻到花香-2019玫瑰花车大赏</a></li>
                        <li><a href="https://www.kpfans.com/article/bzvmejXrv6.html" title="「观点」中国房地产行业，未来之路在何方？（NO.164）">「观点」中国房地产行业，未来之路在何方？（NO.164）</a></li>
                    </ul>
    </div>

    <div id="wpcom-post-thumb-6" class="widget widget_post_thumb"><h3 class="widget-title"><span>随机推荐</span></h3>            
        <ul>
                                       
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/wKv6zeyvjm.html" title="湖北师范大学衣食住行的4000字超全攻略">湖北师范大学衣食住行的4000字超全攻略</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/dVWMKDa4v1.html" title="下午还会起来的">下午还会起来的</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/GB97kEOy9E.html" title="有这4个毛病的人，会越来越没有福气……">有这4个毛病的人，会越来越没有福气……</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/8kWRlBMMvz.html" title="钩针图解｜星形编拼布风坐垫">钩针图解｜星形编拼布风坐垫</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/pO9Pp03p9a.html" title="中国公民在海外工作取得的工资薪金是否需要在国内缴纳个人所得税">中国公民在海外工作取得的工资薪金是否需要在国内缴纳个人所得税</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/qYWAoLxpv4.html" title="全球疫情再度恶化 黄金维持振荡行情">全球疫情再度恶化 黄金维持振荡行情</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/k8WZGK2Q54.html" title="家庭版“有机肥”，这4个配方，你可以试一试，花花草草都喜欢">家庭版“有机肥”，这4个配方，你可以试一试，花花草草都喜欢</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/oa9Ng431Wb.html" title="头晕耳鸣，心律不齐，三火穴帮你调理身体">头晕耳鸣，心律不齐，三火穴帮你调理身体</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/1BWxPXk7W2.html" title="【三秦文学】沧浪：【仙兔仗义世间行之第三十一章：药到病除】（小说连载）">【三秦文学】沧浪：【仙兔仗义世间行之第三十一章：药到病除】（小说连载）</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/0X9a3mOY5L.html" title="最般配却不幸福的情侣面相特征">最般配却不幸福的情侣面相特征</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/ZzW44QdGWV.html" title="听了无数遍的“宁方勿圆”，其实是素描学习中最大的误导？你怎么看？">听了无数遍的“宁方勿圆”，其实是素描学习中最大的误导？你怎么看？</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/yXWyDx7K91.html" title="【诗评诗话】重庆万州|吕传彬:礼闲话唐代“省试诗”">【诗评诗话】重庆万州|吕传彬:礼闲话唐代“省试诗”</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/JP9eBxKjWZ.html" title="来世谁也不是谁的谁了！（看完泪奔）">来世谁也不是谁的谁了！（看完泪奔）</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/EK9Xzp8K5w.html" title="三星堆的谣言3月20日文物局关于三星堆考...">三星堆的谣言3月20日文物局关于三星堆考...</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/1VWGyxe3vP.html" title="宝妈必备，Excel版小学生刷题神器">宝妈必备，Excel版小学生刷题神器</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/7OWgOLDgWJ.html" title="这10种疾病一定不能硬扛，速速就医！">这10种疾病一定不能硬扛，速速就医！</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/oZ9jqzObv3.html" title="推重比达11.7, 最大推力15.8吨，F22的强劲动力，被誉为世界最先进的发动机！">推重比达11.7, 最大推力15.8吨，F22的强劲动力，被誉为世界最先进的发动机！</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/GK92D2qP5L.html" title="方荣翔 京剧《秦香莲》">方荣翔 京剧《秦香莲》</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/oZ9jxk3a53.html" title="31省区市高级法院院长、检察院检察长名单">31省区市高级法院院长、检察院检察长名单</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/7V5wmlKe96.html" title="在凡科建的网站是推广版的，怎样设置百度优化？">在凡科建的网站是推广版的，怎样设置百度优化？</a></p>
                                    </div>
            </li>
                    </ul>
    </div>
        <div id="wpcom-lastest-news-3" class="widget widget_lastest_news"><h3 class="widget-title"><span>热门标签</span></h3>            
        <ul>
                                    
        </ul>
    </div> 
               
</aside>

            </div>
</div>
<footer class="footer width-footer-bar">
    <div class="container">
        <div class="clearfix">
            <div class="footer-col footer-col-logo">
                <img src="//n4.ikafan.com/assetsj/logo.png" alt="开普饭">
            </div>
            <div class="footer-col footer-col-copy">
                  
                <div class="copyright">
                    <p>&#169; <span id="currentFullYear">2024</span>  <a href="/">开普饭</a></p>
                </div>
            </div>
            <div class="footer-col footer-col-sns">

            </div>
        </div>
    </div>
</footer>
    
    
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/icons-2.6.18.js'></script>                            
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/jquery-3.6.0.min.js'></script>
    <!-- <script type='text/javascript' src='https://computeinit.com/wp-includes/js/jquery/jquery-migrate.min.js'></script>                     -->
    <script type='text/javascript'>
    /* <![CDATA[ */
    var _wpcom_js = {};
    /* ]]> */
    </script>
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/main.js'></script>

    <script>
    var _hmt = _hmt || [];
    (function() {
      var hm = document.createElement("script");
      hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
      var s = document.getElementsByTagName("script")[0]; 
      s.parentNode.insertBefore(hm, s);
    })();
    </script> 
 
</body>
</html>